QGIS Application - Bug report #20810
QGIS Server 3 - drawing order of grouped layer
2018-12-14 07:22 AM - Burghardt Scholle

Status: Closed

Priority: High

Assignee: Alessandro Pasotti
Category: QGIS Server

Affected QGIS version:3.4.2

Operating System: Xubuntu 18.04, Windows 7 64bit
Pull Request or Patch supplied:

Crashes QGIS or corrupls data:

Regression?: Yes
Easy fix?: No
Resolution: fixed/implemented

Copied to github as #: 28629

Description

I noticed problems with the drawing order of grouped layers on QGIS Server 3. If | load a WMS service consisting of several (grouped)
layers completely into a desktop GIS, everything is fine. However, if | load several single layers from this WMS service, area and line
layers of a grouped layer are drawn first and "painted over" by other layers (e.g. raster data, see attached screenshots). That's not the

expected behavior and with QGIS Server 2 this problem doesn't exist.
| add a QGIS project file and a geopackage with sample data (see attached zip-file qs3.zip).

Associated revisions

Revision 1ba6b97f - 2019-01-07 01:13 PM - Alessandro Pasotti
[server] Fix layer order rendering when layers are in groups (#8796)
- [server] Fix layer order rendering when layers are in groups
Fixes #20810
- Update test images
- [server] Fix order of layers in subgroups
basically: layers in WMS is specified in a comma separated
list where leftmost layer is drawn first (it's at the bottom)
and QGIS layer order is exactly the opposite: first layer

in the TOP (topmost) is drawn last (it is at the top).

For this reason the server reverses the list before passing
it to the renderer.

- Fix order of layers in test

- Update src/server/services/wms/qgswmsrenderer.cpp

History

#1 - 2019-01-04 10:36 AM - Alessandro Pasotti
- Priority changed from Normal to High
- Regression? changed from No to Yes

#2 - 2019-01-04 11:13 AM - Alessandro Pasotti
- Assignee set to Alessandro Pasotti

#3 - 2019-01-04 11:24 AM - Alessandro Pasotti

- Status changed from Open to Feedback

| don't see any issue with drawing order with current QGIS master, can you please add the exact WMS calls that are causing the problem?

For example:
/?MAP=/Maps/bug_20810/gs3/gserver_GroupedLayer.qgs&SERVICE=WMS&VERSION=1.3.0& REQUEST=GetMap&BBOX=616348.11891968
29218,5810956.442350113764,617354.0284219451714,5812345.854850113392& CRS=EPSG:25832&WIDTH=640&HEIGHT=884& LAYERS=as_areas,Op

as_areas,OpenStreetMap%20(grayscales)&STYLES=default,default&FORMAT=image/jpeg&DP|=192&MAP_RESOLUTION=192&FORMAT_OPTIONS=dpi
PTIONS=dpi:192

#4 - 2019-01-04 12:14 PM - Burghardt Scholle
- File QS3_Layers 2.png added
- File QS3_Layers_1.png added

Hi Alessandro,
thank you so much for taking care of this problem.
| have done tests with the current QGIS Master (for me: code revision d59a346560). The problem still persists. Unfortunately, | can't serve on the fast with

an accurate WMS call :-(. Alternatively, | have made two screenshots of possible settings when adding layers using the "Data Source Manager" in QGIS

Desktop. | hope that's sufficient.

#5 - 2019-01-05 09:57 PM - Alessandro Pasotti
- Status changed from Feedback to In Progress

I've found the issue, working on a fix...

#6 - 2019-01-07 01:12 PM - Alessandro Pasotti
- Status changed from In Progress to Closed
- % Done changed from 0 to 100

Applied in changeset commit:qgis|1ba6b97f74775e9660f0592a517d03ed98aaf504.

#7 - 2019-01-08 07:47 AM - Burghardt Scholle

Thank you for taking care of the problem and solving it. As soon as | have a newer qgis dev version, | will test it again and report afterwards. Currently |

only have the QGIS code version 48db864, which does not contain your changes yet.

#8 - 2019-01-09 07:53 AM - Burghardt Scholle
Good work: | did tests with QGIS master 13ac907 today and can confirm the fix. Thanks a lot!

#9 - 2019-01-09 09:41 AM - Giovanni Manghi
- Resolution set to fixed/implemented

Files

gs3.zip 45.6 KB 2018-12-14 Burghardt Scholle
QS3_actual.png 163 KB 2018-12-14 Burghardt Scholle
QS3_expected.png 197 KB 2018-12-14 Burghardt Scholle
QS3_Layers_1.png 10.8 KB 2019-01-04 Burghardt Scholle
QS83_Layers_2.png 10.5 KB 2019-01-04 Burghardt Scholle
